# Occluder

#### new Cesium.Occluder(occluderBoundingSphere, cameraPosition)
Core/Occluder.js 29

Creates an Occluder derived from an object's position and radius, as well as the camera position. The occluder can be used to determine whether or not other objects are visible or hidden behind the visible horizon defined by the occluder and camera position.

Name | Type | Description
--- | --- | ---
`occluderBoundingSphere` | BoundingSphere | The bounding sphere surrounding the occluder.
`cameraPosition` | Cartesian3 | The coordinate of the viewer/camera.

##### Example:

    // Construct an occluder one unit away from the origin with a radius of one.
    var cameraPosition = Cesium.Cartesian3.ZERO;
    var occluderBoundingSphere = new Cesium.BoundingSphere(new Cesium.Cartesian3(0, 0, -1), 1);
    var occluder = new Cesium.Occluder(occluderBoundingSphere, cameraPosition);

### Members

#### cameraPosition : Cartesian3
Core/Occluder.js 81

The position of the camera.

#### position : Cartesian3
Core/Occluder.js 59

The position of the occluder.

#### radius : Number
Core/Occluder.js 70

The radius of the occluder.

### Methods

#### static Cesium.Occluder.computeOccludeePoint(occluderBoundingSphere, occludeePosition, positions) → Object
Core/Occluder.js 334

Computes a point that can be used as the occludee position to the visibility functions. Use a radius of zero for the occludee radius. Typically, a user computes a bounding sphere around an object that is used for visibility; however it is also possible to compute a point that if seen/not seen would also indicate if an object is visible/not visible. This function is better called for objects that do not move relative to the occluder and is large, such as a chunk of terrain. You are better off not calling this and using the object's bounding sphere for objects such as a satellite or ground vehicle.

Name | Type | Description
--- | --- | ---
`occluderBoundingSphere` | BoundingSphere | The bounding sphere surrounding the occluder.
`occludeePosition` | Cartesian3 | The point where the occludee (bounding sphere of radius 0) is located.
`positions` | Array.<Cartesian3> | List of altitude points on the horizon near the surface of the occluder.

##### Returns:

An object containing two attributes: `occludeePoint` and `valid` which is a boolean value.

##### Throws:

- DeveloperError : `positions` must contain at least one element.
- DeveloperError : `occludeePosition` must have a value other than `occluderBoundingSphere.center`.

##### Example:

    var cameraPosition = new Cesium.Cartesian3(0, 0, 0);
    var occluderBoundingSphere = new Cesium.BoundingSphere(new Cesium.Cartesian3(0, 0, -8), 2);
    var occluder = new Cesium.Occluder(occluderBoundingSphere, cameraPosition);
    var positions = [new Cesium.Cartesian3(-0.25, 0, -5.3), new Cesium.Cartesian3(0.25, 0, -5.3)];
    var tileOccluderSphere = Cesium.BoundingSphere.fromPoints(positions);
    var occludeePosition = tileOccluderSphere.center;
    var occludeePt = Cesium.Occluder.computeOccludeePoint(occluderBoundingSphere, occludeePosition, positions);

#### static Cesium.Occluder.computeOccludeePointFromRectangle(rectangle, ellipsoid) → Object
Core/Occluder.js 399

Computes a point that can be used as the occludee position to the visibility functions from a rectangle.

Name | Type | Default | Description
--- | --- | --- | ---
`rectangle` | Rectangle |  | The rectangle used to create a bounding sphere.
`ellipsoid` | Ellipsoid | `Ellipsoid.WGS84` | optional The ellipsoid used to determine positions of the rectangle.

##### Returns:

An object containing two attributes: `occludeePoint` and `valid` which is a boolean value.

#### static Cesium.Occluder.fromBoundingSphere(occluderBoundingSphere, cameraPosition, result) → Occluder
Core/Occluder.js 124

Creates an occluder from a bounding sphere and the camera position.

Name | Type | Description
--- | --- | ---
`occluderBoundingSphere` | BoundingSphere | The bounding sphere surrounding the occluder.
`cameraPosition` | Cartesian3 | The coordinate of the viewer/camera.
`result` | Occluder | optional The object onto which to store the result.

##### Returns:

The occluder derived from an object's position and radius, as well as the camera position.

#### computeVisibility(occludeeBS) → Visibility
Core/Occluder.js 254

Determine to what extent an occludee is visible (not visible, partially visible, or fully visible).

Name | Type | Description
--- | --- | ---
`occludeeBS` | BoundingSphere | The bounding sphere of the occludee.

##### Returns:

Visibility.NONE if the occludee is not visible, Visibility.PARTIAL if the occludee is partially visible, or Visibility.FULL if the occludee is fully visible.

##### Example:

    var sphere1 = new Cesium.BoundingSphere(new Cesium.Cartesian3(0, 0, -1.5), 0.5);
    var sphere2 = new Cesium.BoundingSphere(new Cesium.Cartesian3(0, 0, -2.5), 0.5);
    var cameraPosition = new Cesium.Cartesian3(0, 0, 0);
    var occluder = new Cesium.Occluder(sphere1, cameraPosition);
    occluder.computeVisibility(sphere2); //returns Visibility.NONE

##### See:

- Occluder#isVisible

#### isBoundingSphereVisible(occludee) → Boolean
Core/Occluder.js 196

Determines whether or not a sphere, the `occludee`, is hidden from view by the occluder.

Name | Type | Description
--- | --- | ---
`occludee` | BoundingSphere | The bounding sphere surrounding the occludee object.

##### Returns:

`true` if the occludee is visible; otherwise `false`.

##### Example:

    var cameraPosition = new Cesium.Cartesian3(0, 0, 0);
    var littleSphere = new Cesium.BoundingSphere(new Cesium.Cartesian3(0, 0, -1), 0.25);
    var occluder = new Cesium.Occluder(littleSphere, cameraPosition);
    var bigSphere = new Cesium.BoundingSphere(new Cesium.Cartesian3(0, 0, -3), 1);
    occluder.isBoundingSphereVisible(bigSphere); //returns true

##### See:

- Occluder#computeVisibility

#### isPointVisible(occludee) → Boolean
Core/Occluder.js 164

Determines whether or not a point, the `occludee`, is hidden from view by the occluder.

Name | Type | Description
--- | --- | ---
`occludee` | Cartesian3 | The point surrounding the occludee object.

##### Returns:

`true` if the occludee is visible; otherwise `false`.

##### Example:

    var cameraPosition = new Cesium.Cartesian3(0, 0, 0);
    var littleSphere = new Cesium.BoundingSphere(new Cesium.Cartesian3(0, 0, -1), 0.25);
    var occluder = new Cesium.Occluder(littleSphere, cameraPosition);
    var point = new Cesium.Cartesian3(0, 0, -3);
    occluder.isPointVisible(point); //returns true

##### See:

- Occluder#computeVisibility